#ifndef COMMON_INCLUDE_H
#define COMMON_INCLUDE_H

/*---- INCLUDE FILES --------------------------------------------------------------------------------------*/
#include <stdlib.h>
#include <string.h>
#include <typedefn.h>
#include <rtwtypes.h>

/*---- TYPEDEFS -------------------------------------------------------------------------------------------*/

/* index_T used for prelookup index/fraction values */
typedef uint16_T index_T;

#include "MotoCoder.h"

/* fault_T used as an index to reference a Fault */
typedef uint32_T fault_T;

/* DataStorage uses matrix types for each built-in type */
typedef struct {
  uint32_T numCols;
  real_T data[1];
} matrix_real_T;

typedef struct {
  uint32_T numCols;
  real32_T data[1];
} matrix_real32_T;

typedef struct {
  uint32_T numCols;
  int8_T data[1];
} matrix_int8_T;

typedef struct {
  uint32_T numCols;
  uint8_T data[1];
} matrix_uint8_T;

typedef struct {
  uint32_T numCols;
  int16_T data[1];
} matrix_int16_T;

typedef struct {
  uint32_T numCols;
  uint16_T data[1];
} matrix_uint16_T;

typedef struct {
  uint32_T numCols;
  int32_T data[1];
} matrix_int32_T;

typedef struct {
  uint32_T numCols;
  uint32_T data[1];
} matrix_uint32_T;

typedef struct {
  uint32_T numCols;
  boolean_T data[1];
} matrix_boolean_T;

typedef struct {
  uint32_T numCols;
  reference_T data[1];
} matrix_reference_T;

typedef struct {
  uint32_T numCols;
  struct_reference_T data[1];
} matrix_struct_reference_T;

/*---- CUSTOM TYPEDEF CODE ---------------------------------------------------------------------------------*/
#define Duty_Cycle_DataStore()         (ETC_B.s4_Switch)
#define Duty_Cycle_DataStore_ELEMS()   (1)
#define Duty_Cycle_DataStore_BYTES()   sizeof(ETC_B.s4_Switch)
#define Duty_Cycle_DataStore_ROWS()    (1)
#define Duty_Cycle_DataStore_COLS()    (1)
#define Error_DataStore()              (ETC_B.s5_Sum)
#define Error_DataStore_ELEMS()        (1)
#define Error_DataStore_BYTES()        sizeof(ETC_B.s5_Sum)
#define Error_DataStore_ROWS()         (1)
#define Error_DataStore_COLS()         (1)
#define P_term_DataStore()             (ETC_B.s5_Product)
#define P_term_DataStore_ELEMS()       (1)
#define P_term_DataStore_BYTES()       sizeof(ETC_B.s5_Product)
#define P_term_DataStore_ROWS()        (1)
#define P_term_DataStore_COLS()        (1)
#define I_term_DataStore()             (ETC_B.s11_MinMax)
#define I_term_DataStore_ELEMS()       (1)
#define I_term_DataStore_BYTES()       sizeof(ETC_B.s11_MinMax)
#define I_term_DataStore_ROWS()        (1)
#define I_term_DataStore_COLS()        (1)
#define Effort_DataStore()             (ETC_B.s12_MinMax)
#define Effort_DataStore_ELEMS()       (1)
#define Effort_DataStore_BYTES()       sizeof(ETC_B.s12_MinMax)
#define Effort_DataStore_ROWS()        (1)
#define Effort_DataStore_COLS()        (1)
#define APP_Raw_DataStore()            (ETC_B.s6_motohawk_ain)
#define APP_Raw_DataStore_ELEMS()      (1)
#define APP_Raw_DataStore_BYTES()      sizeof(ETC_B.s6_motohawk_ain)
#define APP_Raw_DataStore_ROWS()       (1)
#define APP_Raw_DataStore_COLS()       (1)
#define APP_Percent_DataStore()        (ETC_B.s6_Sum1)
#define APP_Percent_DataStore_ELEMS()  (1)
#define APP_Percent_DataStore_BYTES()  sizeof(ETC_B.s6_Sum1)
#define APP_Percent_DataStore_ROWS()   (1)
#define APP_Percent_DataStore_COLS()   (1)
#define TPS_Raw_DataStore()            (ETC_B.s6_DataTypeConversion2)
#define TPS_Raw_DataStore_ELEMS()      (1)
#define TPS_Raw_DataStore_BYTES()      sizeof(ETC_B.s6_DataTypeConversion2)
#define TPS_Raw_DataStore_ROWS()       (1)
#define TPS_Raw_DataStore_COLS()       (1)
#define TPS_Percent_DataStore()        (ETC_B.s6_Sum)
#define TPS_Percent_DataStore_ELEMS()  (1)
#define TPS_Percent_DataStore_BYTES()  sizeof(ETC_B.s6_Sum)
#define TPS_Percent_DataStore_ROWS()   (1)
#define TPS_Percent_DataStore_COLS()   (1)
#define TPSDataProbe_DataStore()       (ETC_B.s1_motohawk_data_read)
#define TPSDataProbe_DataStore_ELEMS() (1)
#define TPSDataProbe_DataStore_BYTES() sizeof(ETC_B.s1_motohawk_data_read)
#define TPSDataProbe_DataStore_ROWS()  (1)
#define TPSDataProbe_DataStore_COLS()  (1)
#define TPSDataVector_DataStore()      (ETC_B.s1_motohawk_data_read1)
#define TPSDataVector_DataStore_ELEMS() (300)
#define TPSDataVector_DataStore_BYTES() sizeof(ETC_B.s1_motohawk_data_read1)
#define TPSDataVector_DataStore_ROWS() (300)
#define TPSDataVector_DataStore_COLS() (1)
#include "Application.h"

/*---- END OF FILE ----------------------------------------------------------------------------------------*/
#endif                                 /* COMMON_INCLUDE_H */
