/*
 * File: ETC.h
 *
 * Real-Time Workshop code generated for Simulink model ETC.
 *
 * Model version                        : 1.269
 * Real-Time Workshop file version      : 7.3  (R2009a)  15-Jan-2009
 * Real-Time Workshop file generated on : Wed Apr 07 13:28:25 2010
 * TLC version                          : 7.3 (Jan 18 2009)
 * C/C++ source code generated on       : Wed Apr 07 13:28:26 2010
 *
 * Target selection: motohawk_ert_rtw.tlc
 * Embedded hardware selection: Specified
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#ifndef RTW_HEADER_ETC_h_
#define RTW_HEADER_ETC_h_
#ifndef ETC_COMMON_INCLUDES_
# define ETC_COMMON_INCLUDES_
#include <stddef.h>
#include <math.h>
#include <string.h>
#include "rtwtypes.h"
#include "Application.h"
#include "rt_MAXd_snf.h"
#include "rt_MINd_snf.h"
#include "rt_SATURATE.h"
#include "rt_nonfinite.h"
#endif                                 /* ETC_COMMON_INCLUDES_ */

#include "ETC_types.h"

/* Child system includes */
#include "ETC_Foreground.h"

/* Macros for accessing real-time model data structure */
#ifndef rtmGetErrorStatus
# define rtmGetErrorStatus(rtm)        ((rtm)->errorStatus)
#endif

#ifndef rtmSetErrorStatus
# define rtmSetErrorStatus(rtm, val)   ((rtm)->errorStatus = (val))
#endif

#ifndef rtmGetStopRequested
# define rtmGetStopRequested(rtm)      ((void*) 0)
#endif

/* Block signals (auto storage) */
typedef struct {
  real_T s6_Sum1;                      /* '<S6>/Sum1' */
  real_T s6_DataTypeConversion2;       /* '<S6>/Data Type Conversion2' */
  real_T s6_Sum;                       /* '<S6>/Sum' */
  real_T s5_Sum;                       /* '<S5>/Sum' */
  real_T s5_Product;                   /* '<S5>/Product' */
  real_T s11_MinMax;                   /* '<S11>/MinMax' */
  real_T s12_MinMax;                   /* '<S12>/MinMax' */
  real_T s4_Switch;                    /* '<S4>/Switch' */
  real_T s7_MinMax;                    /* '<S7>/MinMax' */
  uint16_T s6_motohawk_ain;            /* '<S6>/motohawk_ain' */
  uint8_T s1_motohawk_data_read;       /* '<S1>/motohawk_data_read' */
  uint8_T s1_motohawk_data_read1[300]; /* '<S1>/motohawk_data_read1' */
} BlockIO_ETC;

/* Block states (auto storage) for system '<Root>' */
typedef struct {
  real_T s5_UnitDelay_DSTATE;          /* '<S5>/Unit Delay' */
  real_T s3_UnitDelay_DSTATE;          /* '<S3>/Unit Delay' */
  uint32_T s5_motohawk_delta_time_DWORK1;/* '<S5>/motohawk_delta_time' */
  int_T s1_BasedCounter_MODE;          /* '<S1>/1 Based Counter' */
  uint16_T s14_UnitDelay_DSTATE;       /* '<S14>/Unit Delay' */
  uint16_T s14_UnitDelay1_DSTATE;      /* '<S14>/Unit Delay1' */
  boolean_T s15_UnitDelay_DSTATE;      /* '<S15>/Unit Delay' */
  boolean_T s25_UnitDelay_DSTATE;      /* '<S25>/Unit Delay' */
  boolean_T s13_UnitDelay5_DSTATE;     /* '<S13>/Unit Delay5' */
  boolean_T s13_UnitDelay2_DSTATE;     /* '<S13>/Unit Delay2' */
  boolean_T s13_UnitDelay_DSTATE;      /* '<S13>/Unit Delay' */
  boolean_T s13_UnitDelay1_DSTATE;     /* '<S13>/Unit Delay1' */
  boolean_T s13_UnitDelay3_DSTATE;     /* '<S13>/Unit Delay3' */
  boolean_T s13_UnitDelay4_DSTATE;     /* '<S13>/Unit Delay4' */
} D_Work_ETC;

/* Zero-crossing (trigger) state */
typedef struct {
  ZCSigState ShutdownpoweronECU565128_Trig_ZCE;/* '<S13>/Shutdown power on ECU565-128' */
  ZCSigState SaveNVVarsonetickbeforeMPRDoff_Trig_ZCE;/* '<S13>/Save NV Vars one tick before MPRD off' */
  ZCSigState ProcessorReboot_Trig_ZCE; /* '<S13>/Processor Reboot' */
  ZCSigState PostShutdowntwoticksbeforeMPRDoff_Trig_ZCE;/* '<S13>/Post Shutdown two ticks before MPRD off' */
  ZCSigState Clear_Trig_ZCE;           /* '<S17>/Clear' */
  ZCSigState Clear_Trig_ZCE_m;         /* '<S16>/Clear' */
} PrevZCSigStates_ETC;

/* Real-time Model Data Structure */
struct RT_MODEL_ETC {
  const char_T *errorStatus;
};

/* Block signals (auto storage) */
extern BlockIO_ETC ETC_B;

/* Block states (auto storage) */
extern D_Work_ETC ETC_DWork;

/* External data declarations for dependent source files */

/* Zero-crossing (trigger) state */
extern PrevZCSigStates_ETC ETC_PrevZCSigState;

/* Model entry point functions */
extern void ETC_initialize(boolean_T firstTime);
extern void ETC_step(void);
extern void ETC_terminate(void);

/* Real-time Model object */
extern RT_MODEL_ETC *ETC_M;

/*-
 * The generated code includes comments that allow you to trace directly
 * back to the appropriate location in the model.  The basic format
 * is <system>/block_name, where system is the system number (uniquely
 * assigned by Simulink) and block_name is the name of the block.
 *
 * Use the MATLAB hilite_system command to trace the generated code back
 * to the model.  For example,
 *
 * hilite_system('<S3>')    - opens system 3
 * hilite_system('<S3>/Kp') - opens and selects block Kp which resides in S3
 *
 * Here is the system hierarchy for this model
 *
 * '<Root>' : ETC
 * '<S1>'   : ETC/Foreground
 * '<S2>'   : ETC/Main Power Relay
 * '<S3>'   : ETC/Foreground/1 Based Counter
 * '<S4>'   : ETC/Foreground/Actuator
 * '<S5>'   : ETC/Foreground/Controller
 * '<S6>'   : ETC/Foreground/Sensors
 * '<S7>'   : ETC/Foreground/1 Based Counter/Counter Saturation
 * '<S8>'   : ETC/Foreground/Actuator/motohawk_override_abs
 * '<S9>'   : ETC/Foreground/Actuator/motohawk_override_abs/NewValue
 * '<S10>'  : ETC/Foreground/Actuator/motohawk_override_abs/OldValue
 * '<S11>'  : ETC/Foreground/Controller/I term Saturation
 * '<S12>'  : ETC/Foreground/Controller/Output Saturation
 * '<S13>'  : ETC/Main Power Relay/Background
 * '<S14>'  : ETC/Main Power Relay/Background/Delay
 * '<S15>'  : ETC/Main Power Relay/Background/Display Variable Event Boolean
 * '<S16>'  : ETC/Main Power Relay/Background/Display Variable Event Function-Call
 * '<S17>'  : ETC/Main Power Relay/Background/Display Variable Event Function-Call1
 * '<S18>'  : ETC/Main Power Relay/Background/Post Shutdown two ticks before MPRD off
 * '<S19>'  : ETC/Main Power Relay/Background/Processor Reboot
 * '<S20>'  : ETC/Main Power Relay/Background/Save NV Vars one tick before MPRD off
 * '<S21>'  : ETC/Main Power Relay/Background/Shutdown power on ECU565-128
 * '<S22>'  : ETC/Main Power Relay/Background/motohawk_override_abs
 * '<S23>'  : ETC/Main Power Relay/Background/motohawk_restore_nvmem
 * '<S24>'  : ETC/Main Power Relay/Background/motohawk_store_nvmem
 * '<S25>'  : ETC/Main Power Relay/Background/Delay/MotoHawk S-R Flip-Flop
 * '<S26>'  : ETC/Main Power Relay/Background/Display Variable Event Function-Call/Clear
 * '<S27>'  : ETC/Main Power Relay/Background/Display Variable Event Function-Call1/Clear
 * '<S28>'  : ETC/Main Power Relay/Background/Post Shutdown two ticks before MPRD off/Post Shutdown two ticks before MPRD off
 * '<S29>'  : ETC/Main Power Relay/Background/Save NV Vars one tick before MPRD off/Save NV Vars one tick before MPRD off
 * '<S30>'  : ETC/Main Power Relay/Background/Shutdown power on ECU565-128/Shutdown power on ECU565-128
 * '<S31>'  : ETC/Main Power Relay/Background/motohawk_override_abs/NewValue
 * '<S32>'  : ETC/Main Power Relay/Background/motohawk_override_abs/OldValue
 */
#endif                                 /* RTW_HEADER_ETC_h_ */

/* File trailer for Real-Time Workshop generated code.
 *
 * [EOF]
 */
