
/* MotoCoder_DataStore.h */
/* Generated by MotoCoder */
/* Version: 0.10.5.03240248 */
/* At: 2010-04-07 13:28:39 */
/* Copyright: 2010 Woodward. */


#ifndef MOTOCODER_DATASTORE_H
#define MOTOCODER_DATASTORE_H



#include <MotoCoder.h>
	


/*---- DEFINES --------------------------------------------------------------------------------------------*/

#define NON_VOLATILE_OVERHEAD_BYTES     (4 + 4)
    
  
/*---- TYPEDEFS -------------------------------------------------------------------------------------------*/

/* Name: E_NVStatus ClassID:ENUMDEC EnumDflt:"Illegal" */
typedef enum
{
  NV_LOADING_FACTORY,                   /* EnumTxt:"Currently loading NV from Factory FLASH to RAM" */
  NV_LOADING_EEPROM,                    /* EnumTxt:"Currently loading NV from EEPROM to RAM" */
  NV_STORING_EEPROM,                    /* EnumTxt:"Currently storing NV from RAM to EEPROM" */
  NV_LOADED_FACTORY_BAD_MAGIC,          /* EnumTxt:"Detected new program.  Loaded Factory Defaults from FLASH" */
  NV_LOADED_FACTORY_BAD_CRC,            /* EnumTxt:"CRC failure.  Loaded Factory Defaults from FLASH" */
  NV_LOADED_FACTORY_USER_CMD,           /* EnumTxt:"User requested refresh from Factory Defaults in FLASH." */
  NV_LOADED_EEPROM                      /* EnumTxt:"Successful refresh of EEPROM values from last shutdown" */
} E_NVStatus;

/* Name: E_NVRestore ClassID:ENUMDEC EnumDflt:"Illegal" */
typedef enum
{
  NV_RESTORE_APP,                       /* EnumTxt:"Load saved application values on next startup" */
  NV_RESTORE_DEFAULTS,                  /* EnumTxt:"Load factory defaults on next startup" */
} E_NVRestore;

typedef struct S_NVEEStatus
{
    uint8_T RestoreOnStartup;
    uint8_T RestoreOnFirstStartup;
}S_NVEEStatus;



     

/* NonVolatile namespace */
typedef struct {
    uint32_T NonVolatileFormatID;
    uint32_T crc;
    uint32_T   MotoHawkModelSecondsInUse;
    uint8_T   FaultCommand;
    uint8_T   TPSData[300];
    S_DispFaultManager_T  FaultMarquees[1];
    S_FaultManager_T  VolFaultManager[1];

} NonVolatile_T;
#define MotoHawkModelSecondsInUse_DataStore_BYTES() (sizeof(MotoHawkModelSecondsInUse_DataStore()))
#define MotoHawkModelSecondsInUse_DataStore_ELEMS() (1 * 1)
#define MotoHawkModelSecondsInUse_DataStore_ROWS() (1)
#define MotoHawkModelSecondsInUse_DataStore_COLS() (1)
#define MotoHawkModelSecondsInUse_DataStore()  (NonVolatileWork.MotoHawkModelSecondsInUse)

#define FaultCommand_DataStore_BYTES() (sizeof(FaultCommand_DataStore()))
#define FaultCommand_DataStore_ELEMS() (1 * 1)
#define FaultCommand_DataStore_ROWS() (1)
#define FaultCommand_DataStore_COLS() (1)
#define FaultCommand_DataStore()  (NonVolatileWork.FaultCommand)

#define TPSData_DataStore_BYTES() (sizeof(TPSData_DataStore()))
#define TPSData_DataStore_ELEMS() (1 * 300)
#define TPSData_DataStore_ROWS() (1)
#define TPSData_DataStore_COLS() (300)
#define TPSData_DataStore()  (NonVolatileWork.TPSData)

#define FaultMarquees_DataStore_FaultMarquees()  (NonVolatileWork.FaultMarquees[0])
#define FaultMarquees_DataStore_FaultMarquees_BYTES()  (sizeof(NonVolatileWork.FaultMarquees[0]))
#define FaultMarquees_DataStore_FaultMarquees_ELEMS()  (1)
#define FaultMarquees_DataStore_FaultMarquees_ROWS()  (1)
#define FaultMarquees_DataStore_FaultMarquees_COLS()  (1)
#define FaultMarquees_current_suspected_vardec_DataStore_FaultMarquees_BYTES()  (sizeof(FaultMarquees_current_suspected_vardec_DataStore_FaultMarquees()))
#define FaultMarquees_current_suspected_vardec_DataStore_FaultMarquees_ELEMS()  (1 * 1)
#define FaultMarquees_current_suspected_vardec_DataStore_FaultMarquees_ROWS()  (1)
#define FaultMarquees_current_suspected_vardec_DataStore_FaultMarquees_COLS()  (1)
#define FaultMarquees_current_suspected_vardec_DataStore_FaultMarquees()  (NonVolatileWork.FaultMarquees[0].current_suspected_vardec)
#define FaultMarquees_current_active_vardec_DataStore_FaultMarquees_BYTES()  (sizeof(FaultMarquees_current_active_vardec_DataStore_FaultMarquees()))
#define FaultMarquees_current_active_vardec_DataStore_FaultMarquees_ELEMS()  (1 * 1)
#define FaultMarquees_current_active_vardec_DataStore_FaultMarquees_ROWS()  (1)
#define FaultMarquees_current_active_vardec_DataStore_FaultMarquees_COLS()  (1)
#define FaultMarquees_current_active_vardec_DataStore_FaultMarquees()  (NonVolatileWork.FaultMarquees[0].current_active_vardec)
#define FaultMarquees_current_occurred_vardec_DataStore_FaultMarquees_BYTES()  (sizeof(FaultMarquees_current_occurred_vardec_DataStore_FaultMarquees()))
#define FaultMarquees_current_occurred_vardec_DataStore_FaultMarquees_ELEMS()  (1 * 1)
#define FaultMarquees_current_occurred_vardec_DataStore_FaultMarquees_ROWS()  (1)
#define FaultMarquees_current_occurred_vardec_DataStore_FaultMarquees_COLS()  (1)
#define FaultMarquees_current_occurred_vardec_DataStore_FaultMarquees()  (NonVolatileWork.FaultMarquees[0].current_occurred_vardec)

#define VolFaultManager_DataStore_VolFaultManager()  (NonVolatileWork.VolFaultManager[0])
#define VolFaultManager_DataStore_VolFaultManager_BYTES()  (sizeof(NonVolatileWork.VolFaultManager[0]))
#define VolFaultManager_DataStore_VolFaultManager_ELEMS()  (1)
#define VolFaultManager_DataStore_VolFaultManager_ROWS()  (1)
#define VolFaultManager_DataStore_VolFaultManager_COLS()  (1)
#define VolFaultManager_suspected_DataStore_VolFaultManager_BYTES()  (sizeof(VolFaultManager_suspected_DataStore_VolFaultManager()))
#define VolFaultManager_suspected_DataStore_VolFaultManager_ELEMS()  (1 * 1)
#define VolFaultManager_suspected_DataStore_VolFaultManager_ROWS()  (1)
#define VolFaultManager_suspected_DataStore_VolFaultManager_COLS()  (1)
#define VolFaultManager_suspected_DataStore_VolFaultManager()  (NonVolatileWork.VolFaultManager[0].suspected)
#define VolFaultManager_active_DataStore_VolFaultManager_BYTES()  (sizeof(VolFaultManager_active_DataStore_VolFaultManager()))
#define VolFaultManager_active_DataStore_VolFaultManager_ELEMS()  (1 * 1)
#define VolFaultManager_active_DataStore_VolFaultManager_ROWS()  (1)
#define VolFaultManager_active_DataStore_VolFaultManager_COLS()  (1)
#define VolFaultManager_active_DataStore_VolFaultManager()  (NonVolatileWork.VolFaultManager[0].active)
#define VolFaultManager_occurred_DataStore_VolFaultManager_BYTES()  (sizeof(VolFaultManager_occurred_DataStore_VolFaultManager()))
#define VolFaultManager_occurred_DataStore_VolFaultManager_ELEMS()  (1 * 1)
#define VolFaultManager_occurred_DataStore_VolFaultManager_ROWS()  (1)
#define VolFaultManager_occurred_DataStore_VolFaultManager_COLS()  (1)
#define VolFaultManager_occurred_DataStore_VolFaultManager()  (NonVolatileWork.VolFaultManager[0].occurred)
#define VolFaultManager_last_suspected_fault_DataStore_VolFaultManager_BYTES()  (sizeof(VolFaultManager_last_suspected_fault_DataStore_VolFaultManager()))
#define VolFaultManager_last_suspected_fault_DataStore_VolFaultManager_ELEMS()  (1 * 1)
#define VolFaultManager_last_suspected_fault_DataStore_VolFaultManager_ROWS()  (1)
#define VolFaultManager_last_suspected_fault_DataStore_VolFaultManager_COLS()  (1)
#define VolFaultManager_last_suspected_fault_DataStore_VolFaultManager()  (NonVolatileWork.VolFaultManager[0].last_suspected_fault)
#define VolFaultManager_last_unsuspected_fault_DataStore_VolFaultManager_BYTES()  (sizeof(VolFaultManager_last_unsuspected_fault_DataStore_VolFaultManager()))
#define VolFaultManager_last_unsuspected_fault_DataStore_VolFaultManager_ELEMS()  (1 * 1)
#define VolFaultManager_last_unsuspected_fault_DataStore_VolFaultManager_ROWS()  (1)
#define VolFaultManager_last_unsuspected_fault_DataStore_VolFaultManager_COLS()  (1)
#define VolFaultManager_last_unsuspected_fault_DataStore_VolFaultManager()  (NonVolatileWork.VolFaultManager[0].last_unsuspected_fault)
#define VolFaultManager_last_active_fault_DataStore_VolFaultManager_BYTES()  (sizeof(VolFaultManager_last_active_fault_DataStore_VolFaultManager()))
#define VolFaultManager_last_active_fault_DataStore_VolFaultManager_ELEMS()  (1 * 1)
#define VolFaultManager_last_active_fault_DataStore_VolFaultManager_ROWS()  (1)
#define VolFaultManager_last_active_fault_DataStore_VolFaultManager_COLS()  (1)
#define VolFaultManager_last_active_fault_DataStore_VolFaultManager()  (NonVolatileWork.VolFaultManager[0].last_active_fault)
#define VolFaultManager_last_inactive_fault_DataStore_VolFaultManager_BYTES()  (sizeof(VolFaultManager_last_inactive_fault_DataStore_VolFaultManager()))
#define VolFaultManager_last_inactive_fault_DataStore_VolFaultManager_ELEMS()  (1 * 1)
#define VolFaultManager_last_inactive_fault_DataStore_VolFaultManager_ROWS()  (1)
#define VolFaultManager_last_inactive_fault_DataStore_VolFaultManager_COLS()  (1)
#define VolFaultManager_last_inactive_fault_DataStore_VolFaultManager()  (NonVolatileWork.VolFaultManager[0].last_inactive_fault)
#define VolFaultManager_last_occurred_fault_DataStore_VolFaultManager_BYTES()  (sizeof(VolFaultManager_last_occurred_fault_DataStore_VolFaultManager()))
#define VolFaultManager_last_occurred_fault_DataStore_VolFaultManager_ELEMS()  (1 * 1)
#define VolFaultManager_last_occurred_fault_DataStore_VolFaultManager_ROWS()  (1)
#define VolFaultManager_last_occurred_fault_DataStore_VolFaultManager_COLS()  (1)
#define VolFaultManager_last_occurred_fault_DataStore_VolFaultManager()  (NonVolatileWork.VolFaultManager[0].last_occurred_fault)


/* constants namespace */
typedef struct {
    real32_T   APP_Gain;
    real32_T   APP_Offset;
    real32_T   Counter_max;
    real32_T   Counter_min;
    real32_T   Frequency;
    real32_T   I_term_max;
    real32_T   I_term_min;
    real32_T   Ki;
    real32_T   Kp;
    real32_T   Output_max;
    real32_T   Output_min;
    real32_T   TPSFaultLowerLim;
    real32_T   TPSFaultUpperLim;
    real32_T   TPS_Gain;
    real32_T   TPS_Offset;
    struct_reference_T   ActionsRef[4];
    struct_reference_T   ConstFaultsRef[4];
    struct_reference_T   VolFaultsRef[4];
    uint16_T   ECUP_Threshold;
    uint16_T   TPSDataIndex;
    boolean_T   CounterReset;
    boolean_T   IntReset;
    boolean_T   LogData;
    S_ConstFaultManager_T  ConstFaultManager[1];
    S_ConstFault_T  FaultManager[4];

} Constant_T;
#define APP_Gain_DataStore_BYTES() (sizeof(APP_Gain_DataStore()))
#define APP_Gain_DataStore_ELEMS() (1 * 1)
#define APP_Gain_DataStore_ROWS() (1)
#define APP_Gain_DataStore_COLS() (1)
#define APP_Gain_DataStore()  (ConstantWork.APP_Gain)

#define APP_Offset_DataStore_BYTES() (sizeof(APP_Offset_DataStore()))
#define APP_Offset_DataStore_ELEMS() (1 * 1)
#define APP_Offset_DataStore_ROWS() (1)
#define APP_Offset_DataStore_COLS() (1)
#define APP_Offset_DataStore()  (ConstantWork.APP_Offset)

#define Counter_max_DataStore_BYTES() (sizeof(Counter_max_DataStore()))
#define Counter_max_DataStore_ELEMS() (1 * 1)
#define Counter_max_DataStore_ROWS() (1)
#define Counter_max_DataStore_COLS() (1)
#define Counter_max_DataStore()  (ConstantWork.Counter_max)

#define Counter_min_DataStore_BYTES() (sizeof(Counter_min_DataStore()))
#define Counter_min_DataStore_ELEMS() (1 * 1)
#define Counter_min_DataStore_ROWS() (1)
#define Counter_min_DataStore_COLS() (1)
#define Counter_min_DataStore()  (ConstantWork.Counter_min)

#define Frequency_DataStore_BYTES() (sizeof(Frequency_DataStore()))
#define Frequency_DataStore_ELEMS() (1 * 1)
#define Frequency_DataStore_ROWS() (1)
#define Frequency_DataStore_COLS() (1)
#define Frequency_DataStore()  (ConstantWork.Frequency)

#define I_term_max_DataStore_BYTES() (sizeof(I_term_max_DataStore()))
#define I_term_max_DataStore_ELEMS() (1 * 1)
#define I_term_max_DataStore_ROWS() (1)
#define I_term_max_DataStore_COLS() (1)
#define I_term_max_DataStore()  (ConstantWork.I_term_max)

#define I_term_min_DataStore_BYTES() (sizeof(I_term_min_DataStore()))
#define I_term_min_DataStore_ELEMS() (1 * 1)
#define I_term_min_DataStore_ROWS() (1)
#define I_term_min_DataStore_COLS() (1)
#define I_term_min_DataStore()  (ConstantWork.I_term_min)

#define Ki_DataStore_BYTES() (sizeof(Ki_DataStore()))
#define Ki_DataStore_ELEMS() (1 * 1)
#define Ki_DataStore_ROWS() (1)
#define Ki_DataStore_COLS() (1)
#define Ki_DataStore()  (ConstantWork.Ki)

#define Kp_DataStore_BYTES() (sizeof(Kp_DataStore()))
#define Kp_DataStore_ELEMS() (1 * 1)
#define Kp_DataStore_ROWS() (1)
#define Kp_DataStore_COLS() (1)
#define Kp_DataStore()  (ConstantWork.Kp)

#define Output_max_DataStore_BYTES() (sizeof(Output_max_DataStore()))
#define Output_max_DataStore_ELEMS() (1 * 1)
#define Output_max_DataStore_ROWS() (1)
#define Output_max_DataStore_COLS() (1)
#define Output_max_DataStore()  (ConstantWork.Output_max)

#define Output_min_DataStore_BYTES() (sizeof(Output_min_DataStore()))
#define Output_min_DataStore_ELEMS() (1 * 1)
#define Output_min_DataStore_ROWS() (1)
#define Output_min_DataStore_COLS() (1)
#define Output_min_DataStore()  (ConstantWork.Output_min)

#define TPSFaultLowerLim_DataStore_BYTES() (sizeof(TPSFaultLowerLim_DataStore()))
#define TPSFaultLowerLim_DataStore_ELEMS() (1 * 1)
#define TPSFaultLowerLim_DataStore_ROWS() (1)
#define TPSFaultLowerLim_DataStore_COLS() (1)
#define TPSFaultLowerLim_DataStore()  (ConstantWork.TPSFaultLowerLim)

#define TPSFaultUpperLim_DataStore_BYTES() (sizeof(TPSFaultUpperLim_DataStore()))
#define TPSFaultUpperLim_DataStore_ELEMS() (1 * 1)
#define TPSFaultUpperLim_DataStore_ROWS() (1)
#define TPSFaultUpperLim_DataStore_COLS() (1)
#define TPSFaultUpperLim_DataStore()  (ConstantWork.TPSFaultUpperLim)

#define TPS_Gain_DataStore_BYTES() (sizeof(TPS_Gain_DataStore()))
#define TPS_Gain_DataStore_ELEMS() (1 * 1)
#define TPS_Gain_DataStore_ROWS() (1)
#define TPS_Gain_DataStore_COLS() (1)
#define TPS_Gain_DataStore()  (ConstantWork.TPS_Gain)

#define TPS_Offset_DataStore_BYTES() (sizeof(TPS_Offset_DataStore()))
#define TPS_Offset_DataStore_ELEMS() (1 * 1)
#define TPS_Offset_DataStore_ROWS() (1)
#define TPS_Offset_DataStore_COLS() (1)
#define TPS_Offset_DataStore()  (ConstantWork.TPS_Offset)

#define ActionsRef_DataStore_BYTES() (sizeof(ActionsRef_DataStore()))
#define ActionsRef_DataStore_ELEMS() (1 * 4)
#define ActionsRef_DataStore_ROWS() (1)
#define ActionsRef_DataStore_COLS() (4)
#define ActionsRef_DataStore()  (ConstantWork.ActionsRef)

#define ConstFaultsRef_DataStore_BYTES() (sizeof(ConstFaultsRef_DataStore()))
#define ConstFaultsRef_DataStore_ELEMS() (1 * 4)
#define ConstFaultsRef_DataStore_ROWS() (1)
#define ConstFaultsRef_DataStore_COLS() (4)
#define ConstFaultsRef_DataStore()  (ConstantWork.ConstFaultsRef)

#define VolFaultsRef_DataStore_BYTES() (sizeof(VolFaultsRef_DataStore()))
#define VolFaultsRef_DataStore_ELEMS() (1 * 4)
#define VolFaultsRef_DataStore_ROWS() (1)
#define VolFaultsRef_DataStore_COLS() (4)
#define VolFaultsRef_DataStore()  (ConstantWork.VolFaultsRef)

#define ECUP_Threshold_DataStore_BYTES() (sizeof(ECUP_Threshold_DataStore()))
#define ECUP_Threshold_DataStore_ELEMS() (1 * 1)
#define ECUP_Threshold_DataStore_ROWS() (1)
#define ECUP_Threshold_DataStore_COLS() (1)
#define ECUP_Threshold_DataStore()  (ConstantWork.ECUP_Threshold)

#define TPSDataIndex_DataStore_BYTES() (sizeof(TPSDataIndex_DataStore()))
#define TPSDataIndex_DataStore_ELEMS() (1 * 1)
#define TPSDataIndex_DataStore_ROWS() (1)
#define TPSDataIndex_DataStore_COLS() (1)
#define TPSDataIndex_DataStore()  (ConstantWork.TPSDataIndex)

#define CounterReset_DataStore_BYTES() (sizeof(CounterReset_DataStore()))
#define CounterReset_DataStore_ELEMS() (1 * 1)
#define CounterReset_DataStore_ROWS() (1)
#define CounterReset_DataStore_COLS() (1)
#define CounterReset_DataStore()  (ConstantWork.CounterReset)

#define IntReset_DataStore_BYTES() (sizeof(IntReset_DataStore()))
#define IntReset_DataStore_ELEMS() (1 * 1)
#define IntReset_DataStore_ROWS() (1)
#define IntReset_DataStore_COLS() (1)
#define IntReset_DataStore()  (ConstantWork.IntReset)

#define LogData_DataStore_BYTES() (sizeof(LogData_DataStore()))
#define LogData_DataStore_ELEMS() (1 * 1)
#define LogData_DataStore_ROWS() (1)
#define LogData_DataStore_COLS() (1)
#define LogData_DataStore()  (ConstantWork.LogData)

#define ConstFaultManager_DataStore_ConstFaultManager()  (ConstantWork.ConstFaultManager[0])
#define ConstFaultManager_DataStore_ConstFaultManager_BYTES()  (sizeof(ConstantWork.ConstFaultManager[0]))
#define ConstFaultManager_DataStore_ConstFaultManager_ELEMS()  (1)
#define ConstFaultManager_DataStore_ConstFaultManager_ROWS()  (1)
#define ConstFaultManager_DataStore_ConstFaultManager_COLS()  (1)
#define ConstFaultManager_num_faults_DataStore_ConstFaultManager_BYTES()  (sizeof(ConstFaultManager_num_faults_DataStore_ConstFaultManager()))
#define ConstFaultManager_num_faults_DataStore_ConstFaultManager_ELEMS()  (1 * 1)
#define ConstFaultManager_num_faults_DataStore_ConstFaultManager_ROWS()  (1)
#define ConstFaultManager_num_faults_DataStore_ConstFaultManager_COLS()  (1)
#define ConstFaultManager_num_faults_DataStore_ConstFaultManager()  (ConstantWork.ConstFaultManager[0].num_faults)
#define ConstFaultManager_num_actions_DataStore_ConstFaultManager_BYTES()  (sizeof(ConstFaultManager_num_actions_DataStore_ConstFaultManager()))
#define ConstFaultManager_num_actions_DataStore_ConstFaultManager_ELEMS()  (1 * 1)
#define ConstFaultManager_num_actions_DataStore_ConstFaultManager_ROWS()  (1)
#define ConstFaultManager_num_actions_DataStore_ConstFaultManager_COLS()  (1)
#define ConstFaultManager_num_actions_DataStore_ConstFaultManager()  (ConstantWork.ConstFaultManager[0].num_actions)

#define APPLowerLimFault_DataStore_FaultManager()  (ConstantWork.FaultManager[0])
#define APPLowerLimFault_DataStore_FaultManager_BYTES()  (sizeof(ConstantWork.FaultManager[0]))
#define APPLowerLimFault_DataStore_FaultManager_ELEMS()  (1)
#define APPLowerLimFault_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_mode_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_mode_DataStore_FaultManager()))
#define APPLowerLimFault_mode_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_mode_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_mode_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_mode_DataStore_FaultManager()  (ConstantWork.FaultManager[0].mode)
#define APPLowerLimFault_id_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_id_DataStore_FaultManager()))
#define APPLowerLimFault_id_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_id_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_id_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_id_DataStore_FaultManager()  (ConstantWork.FaultManager[0].id)
#define APPLowerLimFault_test_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_test_DataStore_FaultManager()))
#define APPLowerLimFault_test_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_test_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_test_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_test_DataStore_FaultManager()  (ConstantWork.FaultManager[0].test)
#define APPLowerLimFault_xlim_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_xlim_DataStore_FaultManager()))
#define APPLowerLimFault_xlim_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_xlim_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_xlim_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_xlim_DataStore_FaultManager()  (ConstantWork.FaultManager[0].xlim)
#define APPLowerLimFault_ylim_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_ylim_DataStore_FaultManager()))
#define APPLowerLimFault_ylim_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_ylim_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_ylim_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_ylim_DataStore_FaultManager()  (ConstantWork.FaultManager[0].ylim)
#define APPLowerLimFault_action1_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_action1_DataStore_FaultManager()))
#define APPLowerLimFault_action1_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_action1_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_action1_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_action1_DataStore_FaultManager()  (ConstantWork.FaultManager[0].action1)
#define APPLowerLimFault_action1_condition_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_action1_condition_DataStore_FaultManager()))
#define APPLowerLimFault_action1_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_action1_condition_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_action1_condition_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_action1_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[0].action1_condition)
#define APPLowerLimFault_action2_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_action2_DataStore_FaultManager()))
#define APPLowerLimFault_action2_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_action2_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_action2_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_action2_DataStore_FaultManager()  (ConstantWork.FaultManager[0].action2)
#define APPLowerLimFault_action2_condition_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_action2_condition_DataStore_FaultManager()))
#define APPLowerLimFault_action2_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_action2_condition_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_action2_condition_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_action2_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[0].action2_condition)
#define APPLowerLimFault_action3_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_action3_DataStore_FaultManager()))
#define APPLowerLimFault_action3_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_action3_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_action3_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_action3_DataStore_FaultManager()  (ConstantWork.FaultManager[0].action3)
#define APPLowerLimFault_action3_condition_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_action3_condition_DataStore_FaultManager()))
#define APPLowerLimFault_action3_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_action3_condition_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_action3_condition_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_action3_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[0].action3_condition)
#define APPLowerLimFault_action4_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_action4_DataStore_FaultManager()))
#define APPLowerLimFault_action4_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_action4_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_action4_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_action4_DataStore_FaultManager()  (ConstantWork.FaultManager[0].action4)
#define APPLowerLimFault_action4_condition_DataStore_FaultManager_BYTES()  (sizeof(APPLowerLimFault_action4_condition_DataStore_FaultManager()))
#define APPLowerLimFault_action4_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPLowerLimFault_action4_condition_DataStore_FaultManager_ROWS()  (1)
#define APPLowerLimFault_action4_condition_DataStore_FaultManager_COLS()  (1)
#define APPLowerLimFault_action4_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[0].action4_condition)
 #define APPUpperLimFault_DataStore_FaultManager()  (ConstantWork.FaultManager[1])
#define APPUpperLimFault_DataStore_FaultManager_BYTES()  (sizeof(ConstantWork.FaultManager[1]))
#define APPUpperLimFault_DataStore_FaultManager_ELEMS()  (1)
#define APPUpperLimFault_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_mode_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_mode_DataStore_FaultManager()))
#define APPUpperLimFault_mode_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_mode_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_mode_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_mode_DataStore_FaultManager()  (ConstantWork.FaultManager[1].mode)
#define APPUpperLimFault_id_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_id_DataStore_FaultManager()))
#define APPUpperLimFault_id_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_id_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_id_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_id_DataStore_FaultManager()  (ConstantWork.FaultManager[1].id)
#define APPUpperLimFault_test_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_test_DataStore_FaultManager()))
#define APPUpperLimFault_test_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_test_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_test_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_test_DataStore_FaultManager()  (ConstantWork.FaultManager[1].test)
#define APPUpperLimFault_xlim_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_xlim_DataStore_FaultManager()))
#define APPUpperLimFault_xlim_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_xlim_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_xlim_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_xlim_DataStore_FaultManager()  (ConstantWork.FaultManager[1].xlim)
#define APPUpperLimFault_ylim_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_ylim_DataStore_FaultManager()))
#define APPUpperLimFault_ylim_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_ylim_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_ylim_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_ylim_DataStore_FaultManager()  (ConstantWork.FaultManager[1].ylim)
#define APPUpperLimFault_action1_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_action1_DataStore_FaultManager()))
#define APPUpperLimFault_action1_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_action1_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_action1_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_action1_DataStore_FaultManager()  (ConstantWork.FaultManager[1].action1)
#define APPUpperLimFault_action1_condition_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_action1_condition_DataStore_FaultManager()))
#define APPUpperLimFault_action1_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_action1_condition_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_action1_condition_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_action1_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[1].action1_condition)
#define APPUpperLimFault_action2_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_action2_DataStore_FaultManager()))
#define APPUpperLimFault_action2_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_action2_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_action2_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_action2_DataStore_FaultManager()  (ConstantWork.FaultManager[1].action2)
#define APPUpperLimFault_action2_condition_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_action2_condition_DataStore_FaultManager()))
#define APPUpperLimFault_action2_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_action2_condition_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_action2_condition_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_action2_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[1].action2_condition)
#define APPUpperLimFault_action3_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_action3_DataStore_FaultManager()))
#define APPUpperLimFault_action3_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_action3_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_action3_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_action3_DataStore_FaultManager()  (ConstantWork.FaultManager[1].action3)
#define APPUpperLimFault_action3_condition_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_action3_condition_DataStore_FaultManager()))
#define APPUpperLimFault_action3_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_action3_condition_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_action3_condition_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_action3_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[1].action3_condition)
#define APPUpperLimFault_action4_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_action4_DataStore_FaultManager()))
#define APPUpperLimFault_action4_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_action4_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_action4_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_action4_DataStore_FaultManager()  (ConstantWork.FaultManager[1].action4)
#define APPUpperLimFault_action4_condition_DataStore_FaultManager_BYTES()  (sizeof(APPUpperLimFault_action4_condition_DataStore_FaultManager()))
#define APPUpperLimFault_action4_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define APPUpperLimFault_action4_condition_DataStore_FaultManager_ROWS()  (1)
#define APPUpperLimFault_action4_condition_DataStore_FaultManager_COLS()  (1)
#define APPUpperLimFault_action4_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[1].action4_condition)
 #define TPSLowerLimFault_DataStore_FaultManager()  (ConstantWork.FaultManager[2])
#define TPSLowerLimFault_DataStore_FaultManager_BYTES()  (sizeof(ConstantWork.FaultManager[2]))
#define TPSLowerLimFault_DataStore_FaultManager_ELEMS()  (1)
#define TPSLowerLimFault_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_mode_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_mode_DataStore_FaultManager()))
#define TPSLowerLimFault_mode_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_mode_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_mode_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_mode_DataStore_FaultManager()  (ConstantWork.FaultManager[2].mode)
#define TPSLowerLimFault_id_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_id_DataStore_FaultManager()))
#define TPSLowerLimFault_id_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_id_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_id_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_id_DataStore_FaultManager()  (ConstantWork.FaultManager[2].id)
#define TPSLowerLimFault_test_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_test_DataStore_FaultManager()))
#define TPSLowerLimFault_test_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_test_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_test_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_test_DataStore_FaultManager()  (ConstantWork.FaultManager[2].test)
#define TPSLowerLimFault_xlim_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_xlim_DataStore_FaultManager()))
#define TPSLowerLimFault_xlim_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_xlim_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_xlim_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_xlim_DataStore_FaultManager()  (ConstantWork.FaultManager[2].xlim)
#define TPSLowerLimFault_ylim_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_ylim_DataStore_FaultManager()))
#define TPSLowerLimFault_ylim_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_ylim_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_ylim_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_ylim_DataStore_FaultManager()  (ConstantWork.FaultManager[2].ylim)
#define TPSLowerLimFault_action1_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_action1_DataStore_FaultManager()))
#define TPSLowerLimFault_action1_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_action1_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_action1_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_action1_DataStore_FaultManager()  (ConstantWork.FaultManager[2].action1)
#define TPSLowerLimFault_action1_condition_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_action1_condition_DataStore_FaultManager()))
#define TPSLowerLimFault_action1_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_action1_condition_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_action1_condition_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_action1_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[2].action1_condition)
#define TPSLowerLimFault_action2_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_action2_DataStore_FaultManager()))
#define TPSLowerLimFault_action2_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_action2_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_action2_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_action2_DataStore_FaultManager()  (ConstantWork.FaultManager[2].action2)
#define TPSLowerLimFault_action2_condition_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_action2_condition_DataStore_FaultManager()))
#define TPSLowerLimFault_action2_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_action2_condition_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_action2_condition_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_action2_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[2].action2_condition)
#define TPSLowerLimFault_action3_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_action3_DataStore_FaultManager()))
#define TPSLowerLimFault_action3_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_action3_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_action3_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_action3_DataStore_FaultManager()  (ConstantWork.FaultManager[2].action3)
#define TPSLowerLimFault_action3_condition_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_action3_condition_DataStore_FaultManager()))
#define TPSLowerLimFault_action3_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_action3_condition_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_action3_condition_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_action3_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[2].action3_condition)
#define TPSLowerLimFault_action4_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_action4_DataStore_FaultManager()))
#define TPSLowerLimFault_action4_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_action4_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_action4_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_action4_DataStore_FaultManager()  (ConstantWork.FaultManager[2].action4)
#define TPSLowerLimFault_action4_condition_DataStore_FaultManager_BYTES()  (sizeof(TPSLowerLimFault_action4_condition_DataStore_FaultManager()))
#define TPSLowerLimFault_action4_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSLowerLimFault_action4_condition_DataStore_FaultManager_ROWS()  (1)
#define TPSLowerLimFault_action4_condition_DataStore_FaultManager_COLS()  (1)
#define TPSLowerLimFault_action4_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[2].action4_condition)
 #define TPSUpperLimFault_DataStore_FaultManager()  (ConstantWork.FaultManager[3])
#define TPSUpperLimFault_DataStore_FaultManager_BYTES()  (sizeof(ConstantWork.FaultManager[3]))
#define TPSUpperLimFault_DataStore_FaultManager_ELEMS()  (1)
#define TPSUpperLimFault_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_mode_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_mode_DataStore_FaultManager()))
#define TPSUpperLimFault_mode_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_mode_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_mode_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_mode_DataStore_FaultManager()  (ConstantWork.FaultManager[3].mode)
#define TPSUpperLimFault_id_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_id_DataStore_FaultManager()))
#define TPSUpperLimFault_id_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_id_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_id_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_id_DataStore_FaultManager()  (ConstantWork.FaultManager[3].id)
#define TPSUpperLimFault_test_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_test_DataStore_FaultManager()))
#define TPSUpperLimFault_test_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_test_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_test_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_test_DataStore_FaultManager()  (ConstantWork.FaultManager[3].test)
#define TPSUpperLimFault_xlim_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_xlim_DataStore_FaultManager()))
#define TPSUpperLimFault_xlim_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_xlim_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_xlim_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_xlim_DataStore_FaultManager()  (ConstantWork.FaultManager[3].xlim)
#define TPSUpperLimFault_ylim_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_ylim_DataStore_FaultManager()))
#define TPSUpperLimFault_ylim_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_ylim_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_ylim_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_ylim_DataStore_FaultManager()  (ConstantWork.FaultManager[3].ylim)
#define TPSUpperLimFault_action1_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_action1_DataStore_FaultManager()))
#define TPSUpperLimFault_action1_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_action1_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_action1_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_action1_DataStore_FaultManager()  (ConstantWork.FaultManager[3].action1)
#define TPSUpperLimFault_action1_condition_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_action1_condition_DataStore_FaultManager()))
#define TPSUpperLimFault_action1_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_action1_condition_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_action1_condition_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_action1_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[3].action1_condition)
#define TPSUpperLimFault_action2_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_action2_DataStore_FaultManager()))
#define TPSUpperLimFault_action2_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_action2_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_action2_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_action2_DataStore_FaultManager()  (ConstantWork.FaultManager[3].action2)
#define TPSUpperLimFault_action2_condition_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_action2_condition_DataStore_FaultManager()))
#define TPSUpperLimFault_action2_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_action2_condition_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_action2_condition_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_action2_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[3].action2_condition)
#define TPSUpperLimFault_action3_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_action3_DataStore_FaultManager()))
#define TPSUpperLimFault_action3_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_action3_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_action3_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_action3_DataStore_FaultManager()  (ConstantWork.FaultManager[3].action3)
#define TPSUpperLimFault_action3_condition_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_action3_condition_DataStore_FaultManager()))
#define TPSUpperLimFault_action3_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_action3_condition_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_action3_condition_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_action3_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[3].action3_condition)
#define TPSUpperLimFault_action4_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_action4_DataStore_FaultManager()))
#define TPSUpperLimFault_action4_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_action4_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_action4_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_action4_DataStore_FaultManager()  (ConstantWork.FaultManager[3].action4)
#define TPSUpperLimFault_action4_condition_DataStore_FaultManager_BYTES()  (sizeof(TPSUpperLimFault_action4_condition_DataStore_FaultManager()))
#define TPSUpperLimFault_action4_condition_DataStore_FaultManager_ELEMS()  (1 * 1)
#define TPSUpperLimFault_action4_condition_DataStore_FaultManager_ROWS()  (1)
#define TPSUpperLimFault_action4_condition_DataStore_FaultManager_COLS()  (1)
#define TPSUpperLimFault_action4_condition_DataStore_FaultManager()  (ConstantWork.FaultManager[3].action4_condition)


	/* volatile namespace */
	typedef struct {
	    uint8_T   FaultActionReason[4];

	} Volatile_T;
#define FaultActionReason_DataStore_BYTES() (sizeof(FaultActionReason_DataStore()))
#define FaultActionReason_DataStore_ELEMS() (1 * 4)
#define FaultActionReason_DataStore_ROWS() (1)
#define FaultActionReason_DataStore_COLS() (4)
#define FaultActionReason_DataStore()  (VolatileWork.FaultActionReason)


/* volatile (zero initialized) namespace */
typedef struct {
    real32_T   Duty_Cycle_new;
    int16_T   init_resource_APP;
    int16_T   init_resource_ECUP;
    int16_T   init_resource_ETC;
    int16_T   init_resource_MPRD;
    int16_T   init_resource_TPS;
    boolean_T   Duty_Cycle_ovr;
    boolean_T   MPRD;
    boolean_T   MPRD_KeepAlive;
    boolean_T   MPRD_new;
    boolean_T   MPRD_ovr;
    boolean_T   ProcessorReboot;
    boolean_T   RestoreNVFactoryDefaults;
    boolean_T   StoreNV;
    S_FaultAction_T  Actions[4];
    S_Fault_T  VolFaults[4];

} Volatile_BSS_T;

#define Duty_Cycle_new_DataStore_BYTES() (sizeof(Duty_Cycle_new_DataStore()))
#define Duty_Cycle_new_DataStore_ELEMS() (1 * 1)
#define Duty_Cycle_new_DataStore_ROWS() (1)
#define Duty_Cycle_new_DataStore_COLS() (1)
#define Duty_Cycle_new_DataStore()  (VolatileWork_BSS.Duty_Cycle_new)

#define init_resource_APP_DataStore_BYTES() (sizeof(init_resource_APP_DataStore()))
#define init_resource_APP_DataStore_ELEMS() (1 * 1)
#define init_resource_APP_DataStore_ROWS() (1)
#define init_resource_APP_DataStore_COLS() (1)
#define init_resource_APP_DataStore()  (VolatileWork_BSS.init_resource_APP)

#define init_resource_ECUP_DataStore_BYTES() (sizeof(init_resource_ECUP_DataStore()))
#define init_resource_ECUP_DataStore_ELEMS() (1 * 1)
#define init_resource_ECUP_DataStore_ROWS() (1)
#define init_resource_ECUP_DataStore_COLS() (1)
#define init_resource_ECUP_DataStore()  (VolatileWork_BSS.init_resource_ECUP)

#define init_resource_ETC_DataStore_BYTES() (sizeof(init_resource_ETC_DataStore()))
#define init_resource_ETC_DataStore_ELEMS() (1 * 1)
#define init_resource_ETC_DataStore_ROWS() (1)
#define init_resource_ETC_DataStore_COLS() (1)
#define init_resource_ETC_DataStore()  (VolatileWork_BSS.init_resource_ETC)

#define init_resource_MPRD_DataStore_BYTES() (sizeof(init_resource_MPRD_DataStore()))
#define init_resource_MPRD_DataStore_ELEMS() (1 * 1)
#define init_resource_MPRD_DataStore_ROWS() (1)
#define init_resource_MPRD_DataStore_COLS() (1)
#define init_resource_MPRD_DataStore()  (VolatileWork_BSS.init_resource_MPRD)

#define init_resource_TPS_DataStore_BYTES() (sizeof(init_resource_TPS_DataStore()))
#define init_resource_TPS_DataStore_ELEMS() (1 * 1)
#define init_resource_TPS_DataStore_ROWS() (1)
#define init_resource_TPS_DataStore_COLS() (1)
#define init_resource_TPS_DataStore()  (VolatileWork_BSS.init_resource_TPS)

#define Duty_Cycle_ovr_DataStore_BYTES() (sizeof(Duty_Cycle_ovr_DataStore()))
#define Duty_Cycle_ovr_DataStore_ELEMS() (1 * 1)
#define Duty_Cycle_ovr_DataStore_ROWS() (1)
#define Duty_Cycle_ovr_DataStore_COLS() (1)
#define Duty_Cycle_ovr_DataStore()  (VolatileWork_BSS.Duty_Cycle_ovr)

#define MPRD_DataStore_BYTES() (sizeof(MPRD_DataStore()))
#define MPRD_DataStore_ELEMS() (1 * 1)
#define MPRD_DataStore_ROWS() (1)
#define MPRD_DataStore_COLS() (1)
#define MPRD_DataStore()  (VolatileWork_BSS.MPRD)

#define MPRD_KeepAlive_DataStore_BYTES() (sizeof(MPRD_KeepAlive_DataStore()))
#define MPRD_KeepAlive_DataStore_ELEMS() (1 * 1)
#define MPRD_KeepAlive_DataStore_ROWS() (1)
#define MPRD_KeepAlive_DataStore_COLS() (1)
#define MPRD_KeepAlive_DataStore()  (VolatileWork_BSS.MPRD_KeepAlive)

#define MPRD_new_DataStore_BYTES() (sizeof(MPRD_new_DataStore()))
#define MPRD_new_DataStore_ELEMS() (1 * 1)
#define MPRD_new_DataStore_ROWS() (1)
#define MPRD_new_DataStore_COLS() (1)
#define MPRD_new_DataStore()  (VolatileWork_BSS.MPRD_new)

#define MPRD_ovr_DataStore_BYTES() (sizeof(MPRD_ovr_DataStore()))
#define MPRD_ovr_DataStore_ELEMS() (1 * 1)
#define MPRD_ovr_DataStore_ROWS() (1)
#define MPRD_ovr_DataStore_COLS() (1)
#define MPRD_ovr_DataStore()  (VolatileWork_BSS.MPRD_ovr)

#define ProcessorReboot_DataStore_BYTES() (sizeof(ProcessorReboot_DataStore()))
#define ProcessorReboot_DataStore_ELEMS() (1 * 1)
#define ProcessorReboot_DataStore_ROWS() (1)
#define ProcessorReboot_DataStore_COLS() (1)
#define ProcessorReboot_DataStore()  (VolatileWork_BSS.ProcessorReboot)

#define RestoreNVFactoryDefaults_DataStore_BYTES() (sizeof(RestoreNVFactoryDefaults_DataStore()))
#define RestoreNVFactoryDefaults_DataStore_ELEMS() (1 * 1)
#define RestoreNVFactoryDefaults_DataStore_ROWS() (1)
#define RestoreNVFactoryDefaults_DataStore_COLS() (1)
#define RestoreNVFactoryDefaults_DataStore()  (VolatileWork_BSS.RestoreNVFactoryDefaults)

#define StoreNV_DataStore_BYTES() (sizeof(StoreNV_DataStore()))
#define StoreNV_DataStore_ELEMS() (1 * 1)
#define StoreNV_DataStore_ROWS() (1)
#define StoreNV_DataStore_COLS() (1)
#define StoreNV_DataStore()  (VolatileWork_BSS.StoreNV)

#define BlinkMIL_DataStore_Actions()  (VolatileWork_BSS.Actions[0])
#define BlinkMIL_DataStore_Actions_BYTES()  (sizeof(VolatileWork_BSS.Actions[0]))
#define BlinkMIL_DataStore_Actions_ELEMS()  (1)
#define BlinkMIL_DataStore_Actions_ROWS()  (1)
#define BlinkMIL_DataStore_Actions_COLS()  (1)
#define BlinkMIL_reference_count_DataStore_Actions_BYTES()  (sizeof(BlinkMIL_reference_count_DataStore_Actions()))
#define BlinkMIL_reference_count_DataStore_Actions_ELEMS()  (1 * 1)
#define BlinkMIL_reference_count_DataStore_Actions_ROWS()  (1)
#define BlinkMIL_reference_count_DataStore_Actions_COLS()  (1)
#define BlinkMIL_reference_count_DataStore_Actions()  (VolatileWork_BSS.Actions[0].reference_count)
 #define CutPower_DataStore_Actions()  (VolatileWork_BSS.Actions[1])
#define CutPower_DataStore_Actions_BYTES()  (sizeof(VolatileWork_BSS.Actions[1]))
#define CutPower_DataStore_Actions_ELEMS()  (1)
#define CutPower_DataStore_Actions_ROWS()  (1)
#define CutPower_DataStore_Actions_COLS()  (1)
#define CutPower_reference_count_DataStore_Actions_BYTES()  (sizeof(CutPower_reference_count_DataStore_Actions()))
#define CutPower_reference_count_DataStore_Actions_ELEMS()  (1 * 1)
#define CutPower_reference_count_DataStore_Actions_ROWS()  (1)
#define CutPower_reference_count_DataStore_Actions_COLS()  (1)
#define CutPower_reference_count_DataStore_Actions()  (VolatileWork_BSS.Actions[1].reference_count)
 #define CutThrottle_DataStore_Actions()  (VolatileWork_BSS.Actions[2])
#define CutThrottle_DataStore_Actions_BYTES()  (sizeof(VolatileWork_BSS.Actions[2]))
#define CutThrottle_DataStore_Actions_ELEMS()  (1)
#define CutThrottle_DataStore_Actions_ROWS()  (1)
#define CutThrottle_DataStore_Actions_COLS()  (1)
#define CutThrottle_reference_count_DataStore_Actions_BYTES()  (sizeof(CutThrottle_reference_count_DataStore_Actions()))
#define CutThrottle_reference_count_DataStore_Actions_ELEMS()  (1 * 1)
#define CutThrottle_reference_count_DataStore_Actions_ROWS()  (1)
#define CutThrottle_reference_count_DataStore_Actions_COLS()  (1)
#define CutThrottle_reference_count_DataStore_Actions()  (VolatileWork_BSS.Actions[2].reference_count)
 #define TurnOnMIL_DataStore_Actions()  (VolatileWork_BSS.Actions[3])
#define TurnOnMIL_DataStore_Actions_BYTES()  (sizeof(VolatileWork_BSS.Actions[3]))
#define TurnOnMIL_DataStore_Actions_ELEMS()  (1)
#define TurnOnMIL_DataStore_Actions_ROWS()  (1)
#define TurnOnMIL_DataStore_Actions_COLS()  (1)
#define TurnOnMIL_reference_count_DataStore_Actions_BYTES()  (sizeof(TurnOnMIL_reference_count_DataStore_Actions()))
#define TurnOnMIL_reference_count_DataStore_Actions_ELEMS()  (1 * 1)
#define TurnOnMIL_reference_count_DataStore_Actions_ROWS()  (1)
#define TurnOnMIL_reference_count_DataStore_Actions_COLS()  (1)
#define TurnOnMIL_reference_count_DataStore_Actions()  (VolatileWork_BSS.Actions[3].reference_count)

#define APPLowerLimFaultVol_DataStore_VolFaults()  (VolatileWork_BSS.VolFaults[0])
#define APPLowerLimFaultVol_DataStore_VolFaults_BYTES()  (sizeof(VolatileWork_BSS.VolFaults[0]))
#define APPLowerLimFaultVol_DataStore_VolFaults_ELEMS()  (1)
#define APPLowerLimFaultVol_DataStore_VolFaults_ROWS()  (1)
#define APPLowerLimFaultVol_DataStore_VolFaults_COLS()  (1)
#define APPLowerLimFaultVol_x_DataStore_VolFaults_BYTES()  (sizeof(APPLowerLimFaultVol_x_DataStore_VolFaults()))
#define APPLowerLimFaultVol_x_DataStore_VolFaults_ELEMS()  (1 * 1)
#define APPLowerLimFaultVol_x_DataStore_VolFaults_ROWS()  (1)
#define APPLowerLimFaultVol_x_DataStore_VolFaults_COLS()  (1)
#define APPLowerLimFaultVol_x_DataStore_VolFaults()  (VolatileWork_BSS.VolFaults[0].x)
#define APPLowerLimFaultVol_y_DataStore_VolFaults_BYTES()  (sizeof(APPLowerLimFaultVol_y_DataStore_VolFaults()))
#define APPLowerLimFaultVol_y_DataStore_VolFaults_ELEMS()  (1 * 1)
#define APPLowerLimFaultVol_y_DataStore_VolFaults_ROWS()  (1)
#define APPLowerLimFaultVol_y_DataStore_VolFaults_COLS()  (1)
#define APPLowerLimFaultVol_y_DataStore_VolFaults()  (VolatileWork_BSS.VolFaults[0].y)
 #define APPUpperLimFaultVol_DataStore_VolFaults()  (VolatileWork_BSS.VolFaults[1])
#define APPUpperLimFaultVol_DataStore_VolFaults_BYTES()  (sizeof(VolatileWork_BSS.VolFaults[1]))
#define APPUpperLimFaultVol_DataStore_VolFaults_ELEMS()  (1)
#define APPUpperLimFaultVol_DataStore_VolFaults_ROWS()  (1)
#define APPUpperLimFaultVol_DataStore_VolFaults_COLS()  (1)
#define APPUpperLimFaultVol_x_DataStore_VolFaults_BYTES()  (sizeof(APPUpperLimFaultVol_x_DataStore_VolFaults()))
#define APPUpperLimFaultVol_x_DataStore_VolFaults_ELEMS()  (1 * 1)
#define APPUpperLimFaultVol_x_DataStore_VolFaults_ROWS()  (1)
#define APPUpperLimFaultVol_x_DataStore_VolFaults_COLS()  (1)
#define APPUpperLimFaultVol_x_DataStore_VolFaults()  (VolatileWork_BSS.VolFaults[1].x)
#define APPUpperLimFaultVol_y_DataStore_VolFaults_BYTES()  (sizeof(APPUpperLimFaultVol_y_DataStore_VolFaults()))
#define APPUpperLimFaultVol_y_DataStore_VolFaults_ELEMS()  (1 * 1)
#define APPUpperLimFaultVol_y_DataStore_VolFaults_ROWS()  (1)
#define APPUpperLimFaultVol_y_DataStore_VolFaults_COLS()  (1)
#define APPUpperLimFaultVol_y_DataStore_VolFaults()  (VolatileWork_BSS.VolFaults[1].y)
 #define TPSLowerLimFaultVol_DataStore_VolFaults()  (VolatileWork_BSS.VolFaults[2])
#define TPSLowerLimFaultVol_DataStore_VolFaults_BYTES()  (sizeof(VolatileWork_BSS.VolFaults[2]))
#define TPSLowerLimFaultVol_DataStore_VolFaults_ELEMS()  (1)
#define TPSLowerLimFaultVol_DataStore_VolFaults_ROWS()  (1)
#define TPSLowerLimFaultVol_DataStore_VolFaults_COLS()  (1)
#define TPSLowerLimFaultVol_x_DataStore_VolFaults_BYTES()  (sizeof(TPSLowerLimFaultVol_x_DataStore_VolFaults()))
#define TPSLowerLimFaultVol_x_DataStore_VolFaults_ELEMS()  (1 * 1)
#define TPSLowerLimFaultVol_x_DataStore_VolFaults_ROWS()  (1)
#define TPSLowerLimFaultVol_x_DataStore_VolFaults_COLS()  (1)
#define TPSLowerLimFaultVol_x_DataStore_VolFaults()  (VolatileWork_BSS.VolFaults[2].x)
#define TPSLowerLimFaultVol_y_DataStore_VolFaults_BYTES()  (sizeof(TPSLowerLimFaultVol_y_DataStore_VolFaults()))
#define TPSLowerLimFaultVol_y_DataStore_VolFaults_ELEMS()  (1 * 1)
#define TPSLowerLimFaultVol_y_DataStore_VolFaults_ROWS()  (1)
#define TPSLowerLimFaultVol_y_DataStore_VolFaults_COLS()  (1)
#define TPSLowerLimFaultVol_y_DataStore_VolFaults()  (VolatileWork_BSS.VolFaults[2].y)
 #define TPSUpperLimFaultVol_DataStore_VolFaults()  (VolatileWork_BSS.VolFaults[3])
#define TPSUpperLimFaultVol_DataStore_VolFaults_BYTES()  (sizeof(VolatileWork_BSS.VolFaults[3]))
#define TPSUpperLimFaultVol_DataStore_VolFaults_ELEMS()  (1)
#define TPSUpperLimFaultVol_DataStore_VolFaults_ROWS()  (1)
#define TPSUpperLimFaultVol_DataStore_VolFaults_COLS()  (1)
#define TPSUpperLimFaultVol_x_DataStore_VolFaults_BYTES()  (sizeof(TPSUpperLimFaultVol_x_DataStore_VolFaults()))
#define TPSUpperLimFaultVol_x_DataStore_VolFaults_ELEMS()  (1 * 1)
#define TPSUpperLimFaultVol_x_DataStore_VolFaults_ROWS()  (1)
#define TPSUpperLimFaultVol_x_DataStore_VolFaults_COLS()  (1)
#define TPSUpperLimFaultVol_x_DataStore_VolFaults()  (VolatileWork_BSS.VolFaults[3].x)
#define TPSUpperLimFaultVol_y_DataStore_VolFaults_BYTES()  (sizeof(TPSUpperLimFaultVol_y_DataStore_VolFaults()))
#define TPSUpperLimFaultVol_y_DataStore_VolFaults_ELEMS()  (1 * 1)
#define TPSUpperLimFaultVol_y_DataStore_VolFaults_ROWS()  (1)
#define TPSUpperLimFaultVol_y_DataStore_VolFaults_COLS()  (1)
#define TPSUpperLimFaultVol_y_DataStore_VolFaults()  (VolatileWork_BSS.VolFaults[3].y)


    extern const Constant_T ConstantWork;

extern const NonVolatile_T NonVolatileDefault;

extern NonVolatile_T NonVolatileStorage;

extern NonVolatile_T NonVolatileWork;
        
#define NonVolatile_NonVolatileStatus_DataStore() (NonVolatile_NonVolatileStatus)
        
    /* DataStore */
extern Volatile_T VolatileWork;
extern Volatile_BSS_T VolatileWork_BSS;
extern uint8_T NonVolatile_NonVolatileStatus;
extern void NonVolatile_NonVolatileStatus_Reset(void);
extern void NonVolatile_RestoreDefaultNonVolatile(void);
extern void NonVolatile_StoreNonVolatile(void);
extern void NonVolatile_OpenNonVolatile(void);

#endif

